%
%   hit_the_target.m
%
% Gioco del cannone.
% 

clear all;
close all;
clc;

pos_cannone = [0 0];

noise_ang = 1; % l'angolo dichiarato sara' disturbato da una distr
               % uniforme [-noise_ang +noise_ang] 
noise_pos = 5; % la posizione dichiarata sara' disturbata da una distr
               % uniforme [-noise_pos +noise_pos]

dim_bersaglio = 7;

campo = [-10 110 -10 110]; % limiti del campo di gioco
                          % [min_X max_X min_Y max_Y]

dt = .1; 
g = 9.81;

HIT = 0;

DATA_OK = 0;

while (DATA_OK == 0),
    % angolo di inclinazione del cannone
    ang_cannone = rand(1)*(80-10)+10;
    ang_cannone_dich = ang_cannone+rand(1)*2*noise_ang-noise_ang;
    
    vel_true = rand(1)*50+10;
    x_b = rand(1)*90+10;
    a = deg2rad(ang_cannone);
    y_b = x_b*tan(a)-g*x_b^2/(2*vel_true^2*cos(a)^2);
    pos_bersaglio = [x_b y_b];
    pos_bersaglio_dich = pos_bersaglio+rand(1,2)*noise_pos-noise_pos*[1 1];
    
    if (all(pos_bersaglio_dich > 10)),
        DATA_OK = 1;
    end;
end;
hf = figure;
set(hf, 'WindowStyle', 'docked');
hold on;
plot(pos_bersaglio(1), pos_bersaglio(2), 'x', 'MarkerSize', 10);
plot([-10*cos(deg2rad(ang_cannone_dich)) 0],...
     [-10*sin(deg2rad(ang_cannone_dich)) 0], 'LineWidth', 5);
axis(campo);
axis equal;
%axis off;

prompt_str = sprintf('angolo: %.2f  pos: (%.2f, %.2f)  velocita'': ',...
                     ang_cannone_dich, pos_bersaglio_dich);

fprintf('%.2f %.2f %.2f\n', ang_cannone_dich, pos_bersaglio_dich);

while (HIT==0),

    %x = pos_bersaglio(1);
    %y = pos_bersaglio(2);
    %a = deg2rad(ang_cannone);
    % vel_cannone = sqrt(g*x^2/(2*cos(a)^2*(x*tan(a)-y))),

    % legge vel_cannone
    
    vel_cannone = input(prompt_str);
    
    vel_x = vel_cannone*cos(deg2rad(ang_cannone));
    vel_y = vel_cannone*sin(deg2rad(ang_cannone));
    max_t = (campo(2)-pos_cannone(1))/vel_x;

    t = 0:dt:max_t;
    lt = length(t);
    pos_x = pos_cannone(1) + t*vel_x; 
    pos_y = pos_cannone(2) + t*vel_y - 1/2*9.81*t.^2; 
    
    dist = (pos_x-pos_bersaglio(1)).^2+(pos_y-pos_bersaglio(2)).^2;
    ind = find(dist<dim_bersaglio);
    if (~isempty(ind)),
        pos_x = pos_x(1:ind(1));
        pos_y = pos_y(1:ind(1));
        HIT = 1;
    end;
    
    figure(hf);
    clf;
    hold on;
    plot(pos_x, pos_y, 'o');
    plot([-10*cos(deg2rad(ang_cannone_dich)) 0],...
         [-10*sin(deg2rad(ang_cannone_dich)) 0], 'LineWidth', 5);
    plot(pos_bersaglio(1), pos_bersaglio(2), 'x', 'MarkerSize', 10);
    if (HIT == 1),
        plot(pos_bersaglio(1), pos_bersaglio(2), 'pr', 'MarkerSize', 20);
    end;
        
    axis(campo);
    axis equal;
    %axis off
end;

fprintf('%.2f %.2f %.2f %.2f\n', ang_cannone_dich, pos_bersaglio_dich, vel_cannone);
